/*
 * 消费者
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ConsumersController : BaseController
    {
        public ConsumersController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
        }

        #region 消费者列表

        /// <summary>
        /// 根据条件查询消费者列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(Consumers data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            
            return View();
        }

        #endregion

        #region 根据条件查询消费者列表

        /// <summary>
        /// 消费者列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(Consumers data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("NickName", "1"); //昵称
Fields.Add("CreateDate", "3"); //时间
Fields.Add("Mobile", "1"); //手机号
Fields.Add("WechatUnionid", "1"); //微信Unionid
Fields.Add("AlipayUserId", "1"); //支付宝UserId


            string condition = " and Status>-1";
            

            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("Consumers", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";

            }
            return Json(obj);
        }

        #endregion

        #region 增加消费者

        /// <summary>
        /// 增加或修改消费者信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加消费者

        /// <summary>
        /// 增加或修改消费者信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(Consumers data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("NickName", data.NickName); //昵称
Fields.Add("HeadPhoto", data.HeadPhoto); //头像
Fields.Add("Mobile", data.Mobile); //手机号
Fields.Add("TotalDividend", data.TotalDividend); //累计分红
Fields.Add("TotalIntegral", data.TotalIntegral); //累计积分
Fields.Add("CurIntgegral", data.CurIntgegral); //当前积分
Fields.Add("WechatUnionid", data.WechatUnionid); //微信Unionid
Fields.Add("AlipayUserId", data.AlipayUserId); //支付宝UserId

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Add("Consumers", Fields, 0);
            AddSysLog(data.Id.ToString(), "Consumers", "add");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改消费者

        /// <summary>
        /// 增加或修改消费者信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            Consumers editData = db.Consumers.FirstOrDefault(m => m.Id == Id) ?? new Consumers();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改消费者

        /// <summary>
        /// 增加或修改消费者信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(Consumers data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("NickName", data.NickName); //昵称
Fields.Add("HeadPhoto", data.HeadPhoto); //头像
Fields.Add("Mobile", data.Mobile); //手机号
Fields.Add("TotalDividend", data.TotalDividend); //累计分红
Fields.Add("TotalIntegral", data.TotalIntegral); //累计积分
Fields.Add("CurIntgegral", data.CurIntgegral); //当前积分
Fields.Add("WechatUnionid", data.WechatUnionid); //微信Unionid
Fields.Add("AlipayUserId", data.AlipayUserId); //支付宝UserId

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("Consumers", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"Consumers","update");
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除消费者信息

        /// <summary>
        /// 删除消费者信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"Consumers","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("Consumers", Fields, id);
            }
            db.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"Consumers","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("Consumers", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"Consumers","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Edit("Consumers", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).Sort("Consumers", Sort, Id);
            
            AddSysLog(Id.ToString(), "Consumers", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                db.Consumers.Add(new Consumers()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                db.SaveChanges();
            }
            AddSysLog("0", "Consumers", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(Consumers data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("NickName", "1"); //昵称
Fields.Add("CreateDate", "3"); //时间
Fields.Add("Mobile", "1"); //手机号
Fields.Add("WechatUnionid", "1"); //微信Unionid
Fields.Add("AlipayUserId", "1"); //支付宝UserId


            string condition = " and Status>-1";
            

            Dictionary<string, object> obj = new AdminContent(_accessor.HttpContext, PublicFunction.MainTables).IndexData("Consumers", Fields, "Id desc", "0", 1, 20000, condition, "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["StatusName"] = dic["Status"].ToString() == "1" ? "正常" : "关闭";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            
            result.Add("Fields", ReturnFields);
            AddSysLog("0", "Consumers", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
